{architecute and communication documentation is in C:/icp/06.htm file }
{ the source is commented }
unit _06_Client_frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, ComCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    CS: TClientSocket;
    PB: TProgressBar;
    lblWork: TLabel;
    ListBox1: TListBox;
    Panel1: TPanel;
    cmdStop: TButton;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Splitter1: TSplitter;
    procedure FormShow(Sender: TObject);
    procedure CSRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure CSConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure cmdStopClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function IsPrime(num : integer) : boolean;
  procedure SendRequest;
  procedure Calc;

var
  frmMain: TfrmMain;

  WFrom,
  WTo : integer; { for actual calculated divided work }

implementation

uses _06_client_frmOptions, _06_Client_frmGetPrimeNumbers;

{$R *.DFM}


{ Calc the work }
procedure Calc;
var i : integer;
    count : integer;
    s : string;
begin
  { Inicialize }
  count := 0;
  s := '';

  for i := WFrom to WTo do
  begin
    { it is prime number? }
    if IsPrime(i) then
    begin
      { yes, add it to the list of found prime numbers }
      s := s + inttostr(i) + '||';
      { increase number of prime numbers }
      count := count + 1;
    end;
    { actualize progress }
    frmMain.PB.Position := frmMain.PB.Position + 1;
    { able user to do something }
    Application.ProcessMessages;
  end;

  { Send Result to the server }
  s := 'Result||' + inttostr(count) + '||' + s + '::';
  frmMain.CS.Socket.SendText(s);

  frmMain.listbox1.items.insert(0, 'W: ' + s); { Log }
end;

{ Test if the number 'num' is prime number or not }
function IsPrime(num : integer) : boolean;
var i : integer;
    max : integer;
begin
  if num <= 1 then { first prime number is 2 }
    Result := false
  else if num = 2 then
    Result := true
  else if num mod 2 = 0 then { 2 is tested before }
    Result := false
  else begin
    Result := true;
    max := trunc(sqrt(num)); { maximum number wen need to check }
    i := 3;
    { Repeat until we test all possible numbers or we found some divider number }
    while (i <= max) and (Result) do
    begin
      if num mod i = 0 then
      begin
        { oh, it isn't prime number }
        Result := false;
      end;
      i := i + 2; { + 2 because (num mod 2) test we done }
    end;
  end;
end;

{ Show Options dialog at startup }
procedure TfrmMain.FormShow(Sender: TObject);
begin
  lblWork.caption := 'Ready';

  frmOptions.ShowModal;
end;

procedure TfrmMain.CSRead(Sender: TObject; Socket: TCustomWinSocket);
var s : string;
    sall : string;
    s1 : string;
    i, j : integer;

  { Parse next string from received text }
  function gets(var s : string) : string;
  var poz : integer;
  begin
    poz := pos('||', s); { Position of the next divider }
    if poz = 0 then
    begin
      { If no divider found, use whole text }
      Result := s;
      s := '';
    end
    else begin
      Result := copy(s,1,poz-1); { Get text }
      delete(s,1,poz+1); { Delete the one text }
    end;
  end;

  { Divide main information }
  function getsall(var s : string) : string;
  var poz : integer;
  begin
    poz := pos('::', s); { Position of the next divider }
    if poz = 0 then
    begin
      { If no divider found, use whole text }
      Result := s;
      s := '';
    end
    else begin
      Result := copy(s,1,poz-1); { Get text }
      delete(s,1,poz+1); { Delete the one text }
    end;
  end;

begin
  sall := Socket.ReceiveText; { Receive text }

  s := getsall(sall); {Get next SendData - sometimes the system send two information as one packet }

  while s <> '' do
  begin

    ListBox1.items.insert(0,'R: ' + s); { Log }

    s1 := gets(s); { Get information what is posted }

    { Receive new work }
    if s1 = 'NewWork' then
    begin
      WFrom := strtoint(gets(s));
      WTo := strtoint(gets(s));

      { Inicialize progress }
      lblWork.Caption := 'Calculating from ' + inttostr(WFrom) + ' to ' + inttostr(WTo) + '...';
      PB.Position := 0;
      PB.Max := WTo - WFrom + 1;

      { Calculate the work }
      Calc;
    end
    { The server received result, let request new work }
    else if s1 = 'ReceivedResult' then
    begin
      SendRequest;
    end
    { receive prime numbers in the interval }
    else if s1 = 'ResultGetPrimeNumbers' then
    begin
      j := strtoint(gets(s)); { count of the numbers }
      for i := 0 to j - 1 do
      begin
        { add prime number to the list }
        s1 := gets(s); { last number }
        frmGetPrimeNumbers.lstPrimeNumbers.items.add(s1);
      end;

      s := 'GetNextPrimeNumbers||' + s1 + '||' + frmGetPrimeNumbers.txtIntervalFrom.text + '||' + frmGetPrimeNumbers.txtIntervalTo.Text + '||' + '::';
      Socket.SendText(s);

      ListBox1.items.insert(0, 'W: ' + s);
    end;

    s := getsall(sall);

  end;

end;

{ Send request for work to server }
procedure SendRequest;
begin
  frmMain.CS.Socket.SendText('Request||::');

  frmMain.listbox1.items.insert(0, 'W: Request');

end;

{ We are connected to server, ask for new work }
procedure TfrmMain.CSConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  SendRequest;
end;

{ User choose to disconnect }
procedure TfrmMain.cmdStopClick(Sender: TObject);
begin
  CS.Close;

  lblWork.caption := 'Disconnected.';
end;

{ Show Options dialog }
procedure TfrmMain.Button1Click(Sender: TObject);
begin
  frmOptions.ShowModal;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  frmGetPrimeNumbers.Show;
end;

procedure TfrmMain.ListBox1Click(Sender: TObject);
begin
  memo1.text := listbox1.Items[listbox1.itemindex];
end;

procedure TfrmMain.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  memo1.text := listbox1.Items[listbox1.itemindex];
end;

end.
