{ architecute and communication documentation is in C:/icp/06.htm file }
{ the source is commented }
unit _06_Server_frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls, ComCtrls, ExtCtrls;

type
  TfrmMain = class(TForm)
    PB: TProgressBar;
    SS: TServerSocket;
    lblWork: TLabel;
    ListBox1: TListBox;
    Panel1: TPanel;
    Button1: TButton;
    cmdStop: TButton;
    Memo1: TMemo;
    Splitter1: TSplitter;
    procedure cmdStopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SSClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure SSClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure SSListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  type Work = record
    WFrom,
    WTo : integer;
    Client : hwnd; { handle to the client socket, if 0 no client will work on it }
    Status : integer; { 0 - not calculated, 1 - now calculating (Client <> 0)/done (Client = 0)  }
  end;

procedure DivideWork;

const PARTMAXWORK = 1000;

var
  frmMain: TfrmMain;

  WorkCount : integer;   { Number of divided works to calculate }
  WorkDone : integer;    { Number of divided works which is calculated }
  WorkMin,
  WorkMax : integer;     { Work to calculate }

  Works : array [0..2200000] of Work; { Array with divided work }

  t : text; { text file handle }

implementation

uses _06_Server_frmOptions;


{$R *.DFM}

{ Divide the work to smaller works }
procedure DivideWork;
var i : integer;
    akt : integer;
begin
  WorkDone := 0;
  WorkCount := trunc((WorkMax - WorkMin)/PARTMAXWORK) + 1;
  akt := WorkMin;

  { Set the Works array, last field will be setted later }
  for i:=0 to WorkCount - 1 - 1 do
  begin
    Works[i].WFrom := akt;
    akt := akt + PARTMAXWORK;
    Works[i].WTo := akt - 1;
    Works[i].Client := 0; { null the parameters }
    Works[i].Status := 0;
  end;

  { Last part of the work }
  if (WorkMax - WorkMin) mod PARTMAXWORK <> 0 then
  begin
    Works[WorkCount - 1].WFrom := akt;
    Works[WorkCount - 1].WTo := WorkMax;
    Works[WorkCount - 1].Client := 0;
    Works[WorkCount - 1].Status := 0;
  end;

  { null the position and set maximum }
  frmMain.PB.Position := 0;
  frmMain.PB.Max := WorkCount - 1;
end;

{ Disconnect the server }
procedure TfrmMain.cmdStopClick(Sender: TObject);
begin
 closefile(t);
 SS.Close;

 lblWork.Caption := 'Disconnected.';
end;

{ Show Options dialog at startup }
procedure TfrmMain.FormShow(Sender: TObject);
begin
  frmOptions.ShowModal;
end;

procedure TfrmMain.SSClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var i : integer;
begin
  { Set the divided work which disconnected client calculating as it is NOT done }
  for i := 0 to WorkCount-1 do
  begin
    if Works[i].Client = Socket.Handle then
    begin
      Works[i].Client := 0;
      Works[i].Status := 0;
      break;
    end;
  end;

  {TODO: Je-li nejaky klient volny, rozdeli praci}
end;

procedure TfrmMain.SSClientRead(Sender: TObject; Socket: TCustomWinSocket);
var sall, s, s1 : string;
    pracs, pracs2 : string;
    count : integer;
    i, j : integer;

  { Parse next string from received text }
  function gets(var s : string) : string;
  var poz : integer;
  begin
    poz := pos('||', s); { Position of the next divider }
    if poz = 0 then
    begin
      { If no divider found, use whole text }
      Result := s;
      s := '';
    end
    else begin
      Result := copy(s,1,poz-1); { Get text }
      delete(s,1,poz+1); { Delete the one text }
    end;
  end;

  { Divide main information }
  function getsall(var s : string) : string;
  var poz : integer;
  begin
    poz := pos('::', s); { Position of the next divider }
    if poz = 0 then
    begin
      { If no divider found, use whole text }
      Result := s;
      s := '';
    end
    else begin
      Result := copy(s,1,poz-1); { Get text }
      delete(s,1,poz+1); { Delete the one text }
    end;
  end;


begin
  sall := Socket.ReceiveText; { Receive text }

  s := getsall(sall); {Get next SendData - sometimes the system send two information as one packet }

  while s <> '' do
  begin

    ListBox1.items.insert(0,'R: ' + s); { Log }

    s1 := gets(s); { Get information what is posted }

    { Request a new work }
    if s1 = 'Request' then
    begin
      { Find free work }
      for i := 0 to WorkCount - 1 do
      begin
        if Works[i].Status = 0 then
        begin
          { If there is a free work }

          { Send the new task to the client }
          s := 'NewWork||' + inttostr(Works[i].WFrom) + '||' + inttostr(Works[i].WTo) + '||' + '::';
          Works[i].Status := 1; { It is calculated now }
          Works[i].Client := Socket.Handle;

          Socket.SendText(s);

          listbox1.items.insert(0, 'W: ' + s); { Log }

          break; { Jump from the loop }
        end;
      end;
    end
    { Client sent the Result }
    else if s1='Result' then
    begin
      { How many prime numbers the client sent? }
      j := strtoint(gets(s));
      { Write them to the output file }
      for i := 0 to j - 1 do
        writeln(t, gets(s));

      { Set the work as done }
      for i := 0 to WorkCount - 1 do
      begin
        if Works[i].Client = Socket.handle then
        begin
          Works[i].Client := 0;
          Works[i].Status := 1;

          { Send that Result was succesfull received }
          Socket.SendText('ReceivedResult||::');

          listbox1.items.insert(0, 'W: ReceivedResult'); { Log }
        end;

      end;

      { Actualize progress }
      PB.Position := PB.Position + 1;

      WorkDone := WorkDone + 1;
      if WorkDone = WorkCount then
      begin
        { If all is done close the file and disconnect }
        closefile(t);
        SS.Close;
        lblWork.Caption := 'Done.';
      end;
    end
    else if (s1 = 'GetPrimeNumbers') or (s1 = 'GetNextPrimeNumbers') then
    begin
      closefile(t); { close output file }

      reset(t); { open the file for read }

      if s1 = 'GetNextPrimeNumbers' then
      begin
        pracs := gets(s); { last received prime number }
        pracs2 := '';
        { skip all prime numbers befor last received prime number by client }
        while (pracs <> pracs2) and (not eof(t)) do
        begin
          readln(t, pracs2);
        end;
      end;

      i := strtoint(gets(s)); { from }
      j := strtoint(gets(s)); { to }

      s := ''; { null the output text }
      count := 0;
      while not eof(t) do
      begin
        readln(t, pracs); { Read one number from a file }
        if (strtoint(pracs) >= i) and (strtoint(pracs) <= j) then
        begin
          { Yes, it is in the interval, add it to the list }
          s := s + pracs + '||';
          count := count + 1;

          { If the result is too big, send only part
            the client ask for next part }
          if length(s) > 1000 then
            break;
        end;
      end;

      { if there is something to send }
      if count > 0 then
      begin
        s := 'ResultGetPrimeNumbers||' + inttostr(count) + '||' + s + '::';
        Socket.SendText(s);
        ListBox1.items.insert(0, 'W: ' + s); { Log }
      end;

      closefile(t); { close file }

      append(t); { open output file for write as append }
    end;

    s := getsall(sall);

  end;

  { user able to do something }
  Application.ProcessMessages;
end;

procedure TfrmMain.SSListen(Sender: TObject; Socket: TCustomWinSocket);
begin
  { Open the output file }
  assignfile(t,'C:\icp\_05_output.txt');
  rewrite(t);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
end;

{ Show Options dialog }
procedure TfrmMain.Button1Click(Sender: TObject);
begin
  frmOptions.ShowModal;
end;

procedure TfrmMain.ListBox1Click(Sender: TObject);
begin
  memo1.text := listbox1.Items[listbox1.itemindex];
end;

procedure TfrmMain.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
  memo1.text := listbox1.Items[listbox1.itemindex];
end;

end.
